Subject: Re: bug#52394: 27.2; Isearch with char folding enableddoesn’t match equivalent strings

From: Eli Zaretskii <[email-masked]>
Date: Sun, 12 Dec 2021 20:43:53 +0200

> From: Juri Linkov <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Sun, 12 Dec 2021 20:30:10 +0200
> 
> >> > Doesn't this change the default behavior?
> >> 
> >> No, no change in the default behavior.
> >
> > Then I guess the doc string of the defcustom is confusing?  Can you
> > make it more clear wrt what each value means in practice?
> 
> Here is the doc string.  How do you propose to make it more clear?
> 
>     "Non-nil means to override all default folding characters.
>   When nil, the equivalence table is populated with the default set
>   of equivalent chars, and you can remove unneeded characters using
>   `char-fold-exclude', and add own characters using `char-fold-include'.
>   But when this variable is customized to non-nil, you start with
>   an empty table where you can add only own characters
>   using `char-fold-include'."

My reading of this is that the feature by default will not work at all:
since the default value is not nil, the doc string says that I "start
with an empty table", so no folding will happen.  Is that what you
meant?  And if so, how isn't this a change in behavior?  In Emacs 27
the folding works by default and finds equivalent characters without
any user intervention.

What am I missing?